--- preferences.php	2006-11-19 23:09:14.031392545 +0200
+++ /usr/share/eventum/htdocs/preferences.php	2006-12-07 04:42:55.655367834 +0200
@@ -27,7 +27,12 @@
 //
 // @(#) $Id: s.preferences.php 1.9 04/01/07 15:50:18-00:00 jpradomaia $
 //
-include_once("config.inc.php");
+
+// do language prefs early
+if (@$_POST['language']) {
+    define('SKIP_LANGUAGE_INIT', true);
+}
+include_once("config.inc.php");
 include_once(APP_INC_PATH . "class.template.php");
 include_once(APP_INC_PATH . "class.auth.php");
 include_once(APP_INC_PATH . "class.prefs.php");
@@ -35,16 +40,20 @@
 include_once(APP_INC_PATH . "class.date.php");
 include_once(APP_INC_PATH . "db_access.php");
 
-$tpl = new Template_API();
-$tpl->setTemplate("preferences.tpl.html");
-
 Auth::checkAuthentication(APP_COOKIE);
 
 $usr_id = Auth::getUserID();
 
+$tpl = new Template_API();
+$tpl->setTemplate("preferences.tpl.html");
+
 if (@$HTTP_POST_VARS["cat"] == "update_account") {
+    $res = User::setLang(Auth::getUserID(), $_POST['language']);
+    // do the language init we skipped earlier
+    Language::setPreference();
+    $tpl->assign('update_lang_result', $res);
+
     $res = Prefs::set($usr_id);
-    $tpl->assign('update_lang_result', User::setLang(Auth::getUserID(), $_POST['language']));
     $tpl->assign('update_account_result', $res);
     User::updateSMS($usr_id, @$HTTP_POST_VARS['sms_email']);
 } elseif (@$HTTP_POST_VARS["cat"] == "update_name") {
Index: setup/config.inc.php
===================================================================
--- setup/config.inc.php	(revision 3162)
+++ setup/config.inc.php	(working copy)
@@ -178,7 +178,9 @@
 $HTTP_POST_VARS = Misc::dispelMagicQuotes($HTTP_POST_VARS);
 $_REQUEST = Misc::dispelMagicQuotes($_REQUEST);
 
-Language::setPreference();
+if (!defined('SKIP_LANGUAGE_INIT')) {
+    Language::setPreference();
+}
 
 // set charset
 header("Content-Type: text/html; charset=" . APP_CHARSET);
